<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Util\Utilities;

class ParcnegocioParceriaOperadorInterlocutorController extends SMCrud {
    
    protected $dataSourceName = "parcnegocio_parceria_operador_interlocutor";
    protected $clienteSignatarioPrestador;
    
    public function __construct($crudService, $environment, $clienteSignatarioPrestador) {
        parent::__construct($crudService, $environment);
        $this->clienteSignatarioPrestador = $clienteSignatarioPrestador;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $request->getFilterCriteria()->addCondition("CDCLIENTE", "=", $this->clienteSignatarioPrestador); 
            parent::find($request, $response);
            $erro = $response->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
            $rows = $response->getDataSets()[0]->getRows();
            $response->setDataSets(array(new DataSet($this->dataSourceName, $rows)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>