<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\Sm00031000MapaRecursosAgendadosService;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;

class Sm00031000MapaRecursosAgendadosController extends SMCrud {
    
    protected $dataSourceName = "fct_recursos_agendamento_contrato";
    protected $mapaService;

    public function __construct($crudService, $environment, Sm00031000MapaRecursosAgendadosService $mapaService) {
        parent::__construct($crudService, $environment);
        $this->mapaService = $mapaService;
    }
    
    /**
    *  A função que busca o recursos agendados para ser mostrados no Swipe para cada marcador no mapa.
    * Têm com entrada o local de atendimento retorna os recursos deste local 
    */
    
    public function getRecursos(DTO\Request\Filter $request, DTO\Response $response) {
    
        $row = $request->getFilterCriteria()->getConditions();
        $localDeatendimento = $row[0]["value"]; 
        $recursos = $this->mapaService->getRecursos($localDeatendimento);
        $nmrecurso = new DataSet('DADOS', $recursos);
        $response->addDataSet($nmrecurso);
    }
}

?>