<?php

namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00024000ModeloDocumentosFactory;
use Teknisa\SM\Service\SmDocumentosService;

class Sm00024000ModeloDocumentosService {
    
    protected $modeloDocFactory;
    protected $documentosService;
    protected $fileServerBaseUrl;
    
    public function __construct(Sm00024000ModeloDocumentosFactory $modeloDocFactory, SmDocumentosService $documentosService, $fileServerBaseUrl) {
        $this->modeloDocFactory  = $modeloDocFactory;
        $this->documentosService = $documentosService;
        $this->fileServerBaseUrl = $fileServerBaseUrl;
    }
    
    public function limparAnexoDoModelo($nrseqmoddocfct, $nrorg) {
        $params = array(
            "NRSEQMODDOCFCT" => $nrseqmoddocfct,
            "NRORG"          => $nrorg
        );
        
        $this->modeloDocFactory->limparAnexoDoModelo($params);
    }

    public function validarInativarModelo($nrseqmoddocfct, $nrorg) {
        $params = array(
            "NRSEQMODDOCFCT" => $nrseqmoddocfct,
            "NRORG"        => $nrorg
        );

        return $this->modeloDocFactory->validarInativarModelo($params);
    }
    
    /**
     * Baixa do fileServe o arquivo de documento e salva em uma pasta temporária
    **/
    public function downloadDocFileServer($nrseqmoddocfct, $nrorg) {
        $result = array();
        $params = array(
            "NRSEQMODDOCFCT" => $nrseqmoddocfct,
            "NRORG"          => $nrorg
        );

        $documento = $this->modeloDocFactory->getDocumento($params);
        if(count($documento) > 0) {
            $microtime = microtime(true);
            $microtime = str_replace(".", "_", $microtime);
            
            $documento = $documento[0];
            $fileDir   = $this->fileServerBaseUrl . $documento["DSCAMINHOARQ"];
            $fileName  = $microtime . "_" . str_replace(",", "_", $documento["NMARQUIVO"]);
            
            $fileDirTemp = $this->documentosService->downloadDocFileServer($fileDir, $fileName, $nrorg);
            $fileName    = base64_encode($fileName);
            $result = "/downloadArquivo?requestType=Row&row[FILENAME]=" . $fileName . "&row[FILETYPE]=" . $documento["DSTIPO"];
        }
        
        return $result;
    }
}

?>