/* Sistemas Integrados TECNISA
   Financeiro

Descrio:
Script para atualizar a Tabela CONTCORR com os mnemonicos dos campos
   DSDACNOSNUMR = Nosso Nmero
   DSNOSNUMCORR = DAC do Nosso Nmero
Para os Bancos:
   237: BRADESCO
   341: ITAU
   399: HSBC
   422: SAFRA
   409: UNIBANCO
   001: BANCO DO BRASIL
   389: MERCANTIL
Para aplicar 
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1003_FINTMP_ATUALIZA_NOSSONUMERO.SQL
*/

UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[CARE02][NSNE11]',
   DSNOSNUMCORR = '[ANOD02][SEQ09]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B
                 WHERE
                    CDBANCCNAB = '237')
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[CARE03][NSNE08]',
   DSNOSNUMCORR = '[SEQ08]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B, EMPRBANC E
                 WHERE
                    B.CDBANCCNAB = '341'  AND
                    B.CDBANCO = E.CDBANCO AND
                    E.CDCARTCOBR IN ('126', '131', '146', '150', '168'))
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[AGEE04][CTCE05][CARE03][NSNE08]',
   DSNOSNUMCORR = '[SEQ08]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                     FROM  BANCO B, EMPRBANC E
                     WHERE
                       B.CDBANCCNAB = '341'  AND
                       B.CDBANCO = E.CDBANCO AND
                       NOT E.CDCARTCOBR IN ('126', '131', '146', '150', '168'))
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[NSNE08]',
   DSNOSNUMCORR = '[SEQ08]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B
                 WHERE
                    CDBANCCNAB = '422')
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '1[NSNE11]',
   DSNOSNUMCORR = '[SEQ11]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B
                 WHERE
                    CDBANCCNAB = '409')
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[NSNE11]',
   DSNOSNUMCORR = '[SEQ11]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B
                 WHERE
                    CDBANCCNAB = '001')
/
UPDATE CONTCORR
SET
   DSDACNOSNUMR = '[AGEE04][NSNE10]',
   DSNOSNUMCORR = '[SEQ10]'
WHERE
   DSDACNOSNUMR IS NULL AND
   DSNOSNUMCORR IS NULL AND
   CDBANCO IN (SELECT B.CDBANCO
                 FROM  BANCO B
                 WHERE
                    CDBANCCNAB = '389')
/

COMMIT
/

