/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 0070_SDXSTPO_ATUALIZA_CLIENTE_SAP.sql

Descrio:
Atualiza as informaes dos clientes no "TecFood" de acordo com
as alteraes sobre o cadastro de fornecedor no sistema "SAC".

Criao:
22/04/2008 Raquel Cunha
*/

CREATE OR REPLACE
PROCEDURE ATUALIZA_CLIENTE_SAP
  (P_CDCLIENTE    IN VARCHAR2,
   P_NRINSJURCLIE IN VARCHAR2,
   P_IDTPIJURCLIE IN VARCHAR2,
   P_NMRAZSOCCLIE IN VARCHAR2,
   P_NMFANTCLIE   IN VARCHAR2,
   P_NRINSESTCLIE IN VARCHAR2,
   P_IDCLIEATIV   IN VARCHAR2 DEFAULT 'S',
   P_CDGRUPOFISC  IN VARCHAR2,
   P_IDTPENDECLIE IN VARCHAR2,
   P_DSENDECLIE   IN VARCHAR2,
   P_NMBAIRCLIE   IN VARCHAR2,
   P_CDPAIS       IN VARCHAR2,
   P_SGESTADO     IN VARCHAR2,
   P_NMMUNICIPIO  IN VARCHAR2,
   P_NRCEPCLIE    IN VARCHAR2,
   P_IDFUNCAO     IN VARCHAR2) IS

   V_SGESTADO        VARCHAR2(2);
   V_CDMUNICIPIO     VARCHAR2(4);
   V_CDMUNICIPIOTEMP VARCHAR2(4);
   V_CDCLIENTE       VARCHAR2(21);
   V_CDCLIENTEND     VARCHAR2(21);
BEGIN
   IF P_SGESTADO IS NULL THEN
      SELECT MAX(SGESTADO)
      INTO V_SGESTADO
      FROM ESTADO
      WHERE CDPAIS = P_CDPAIS AND
            SGESTADO =  'ZZ';
      IF V_SGESTADO IS NULL THEN
         INSERT INTO ESTADO
            (CDPAIS, SGESTADO, NMESTADO)
         VALUES
            (P_CDPAIS, 'ZZ', 'TEMPORARIO');
         COMMIT;
         V_SGESTADO := 'ZZ';
      END IF;
   ELSE
      V_SGESTADO := P_SGESTADO;
   END IF;

   IF P_NMMUNICIPIO IS NOT NULL THEN
      SELECT MAX(CDMUNICIPIO)
      INTO V_CDMUNICIPIO
      FROM MUNICIPIO
      WHERE (CDPAIS   = P_CDPAIS)   AND
            (SGESTADO = V_SGESTADO) AND
            (UPPER(NMMUNICIPIO) LIKE P_NMMUNICIPIO);

      IF V_CDMUNICIPIO IS NULL THEN
         SELECT MAX(CDMUNICIPIO)
         INTO V_CDMUNICIPIOTEMP
         FROM MUNICIPIO
         WHERE (CDPAIS   = P_CDPAIS)   AND
               (SGESTADO = V_SGESTADO) AND
               (CDMUNICIPIO = '9999');
         IF V_CDMUNICIPIOTEMP IS NULL THEN
            INSERT INTO MUNICIPIO
               (CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO)
            VALUES
               (P_CDPAIS, V_SGESTADO, '9999', 'TEMPORARIO');
            COMMIT;
            V_CDMUNICIPIO := '9999';
         ELSE
            V_CDMUNICIPIO := V_CDMUNICIPIOTEMP;
         END IF;
      END IF;
   ELSE
      SELECT MAX(CDMUNICIPIO)
      INTO V_CDMUNICIPIOTEMP
      FROM MUNICIPIO
      WHERE (CDPAIS   = P_CDPAIS)   AND
            (SGESTADO = V_SGESTADO) AND
            (CDMUNICIPIO = '9999');
      IF V_CDMUNICIPIOTEMP IS NULL THEN
         INSERT INTO MUNICIPIO
            (CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO)
         VALUES
            (P_CDPAIS, V_SGESTADO, '9999', 'TEMPORARIO');
         COMMIT;
         V_CDMUNICIPIO := '9999';
      ELSE
         V_CDMUNICIPIO := V_CDMUNICIPIOTEMP;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'I' THEN
      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTE
      FROM CLIENTE
      WHERE (CDCLIENTE = P_CDCLIENTE);

      IF V_CDCLIENTE IS NULL THEN
         INSERT INTO CLIENTE
            (CDCLIENTE, NRINSJURCLIE, IDTPIJURCLIE, NMRAZSOCCLIE,
             NMFANTCLIE, NRINSESTCLIE, IDCLIEATIV, CDGRUPOFISC)
         VALUES
            (P_CDCLIENTE, P_NRINSJURCLIE, P_IDTPIJURCLIE, P_NMRAZSOCCLIE,
             P_NMFANTCLIE, P_NRINSESTCLIE, P_IDCLIEATIV, P_CDGRUPOFISC);
         COMMIT;
      END IF;

      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTEND
      FROM ENDECLIE
      WHERE (CDCLIENTE    = P_CDCLIENTE) AND
            (IDTPENDECLIE = P_IDTPENDECLIE);

      IF V_CDCLIENTEND IS NULL THEN
         INSERT INTO ENDECLIE
             (CDCLIENTE, IDTPENDECLIE, DSENDECLIE, NMBAIRCLIE,
              CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPCLIE)
         VALUES
             (P_CDCLIENTE, P_IDTPENDECLIE, P_DSENDECLIE, P_NMBAIRCLIE,
              P_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, P_NRCEPCLIE);
         COMMIT;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'A' THEN
      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTE
      FROM CLIENTE
      WHERE (CDCLIENTE = P_CDCLIENTE);

      IF V_CDCLIENTE IS NOT NULL THEN
         UPDATE CLIENTE
         SET NRINSJURCLIE = P_NRINSJURCLIE,
             NMRAZSOCCLIE = P_NMRAZSOCCLIE,
             NMFANTCLIE   = P_NMFANTCLIE,
             NRINSESTCLIE = P_NRINSESTCLIE,
             CDGRUPOFISC  = P_CDGRUPOFISC
         WHERE CDCLIENTE  = P_CDCLIENTE;
         COMMIT;
      END IF;

      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTEND
      FROM ENDECLIE
      WHERE (CDCLIENTE   = P_CDCLIENTE) AND
            (IDTPENDECLIE = P_IDTPENDECLIE);

      IF V_CDCLIENTEND IS NOT NULL THEN
         UPDATE ENDECLIE
         SET CDPAIS      = P_CDPAIS,
             SGESTADO    = V_SGESTADO,
             CDMUNICIPIO = V_CDMUNICIPIO,
             DSENDECLIE  = P_DSENDECLIE,
             NMBAIRCLIE  = P_NMBAIRCLIE,
             NRCEPCLIE   = P_NRCEPCLIE
         WHERE
            CDCLIENTE   = P_CDCLIENTE AND
            IDTPENDECLIE = P_IDTPENDECLIE;
         COMMIT;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'E' THEN

      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTEND
      FROM ENDECLIE
      WHERE (CDCLIENTE   = P_CDCLIENTE);

      IF V_CDCLIENTEND IS NOT NULL THEN
         DELETE FROM ENDECLIE
         WHERE
            CDCLIENTE = P_CDCLIENTE;
         COMMIT;
      END IF;

      SELECT MAX(CDCLIENTE)
      INTO V_CDCLIENTE
      FROM CLIENTE
      WHERE (CDCLIENTE = P_CDCLIENTE);

      IF V_CDCLIENTE IS NOT NULL THEN
         DELETE FROM CLIENTE
         WHERE CDCLIENTE = P_CDCLIENTE;
         COMMIT;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_CLIENTE_SAP','5.01.043'); END;
/

